subroutine Pump1_MainSolver
    
    use SimulationVariables
    
    Implicit none
    
    
    
              
    if (data%State%Pump(1)%Throttle<=0.d0) then
        data%State%Pump(1)%K_throttle = 1
    end if
    
    
    if((any(data%State%Pump(1)%AssignmentSwitchh==(/1,2,3,4,9,10/))) .and. (data%State%Pump(1)%Switch==-1) .and. (data%State%Pump(1)%K_throttle==1) .and. (data%State%Pump(1)%PowerFailMalf==0) .and. (data%State%Pump(1)%Failure==0)) then
        
        data%State%Pump(1)%SoundBlower = .true.
        data%State%Pump(1)%BLWR        = 1
        
        !========================== Pump 1 Rate limit ==========================
        if (((data%State%Pump(1)%N_new-data%State%Pump(1)%N_old)/data%State%Pump(1)%time_step)>data%State%Pump(1)%RateChange) then
            data%State%Pump(1)%Speed =(data%State%Pump(1)%RateChange*data%State%Pump(1)%time_step)+data%State%Pump(1)%N_old                 ![RPM]
        else if (((data%State%Pump(1)%N_old-data%State%Pump(1)%N_new)/data%State%Pump(1)%time_step)>data%State%Pump(1)%RateChange) then
            data%State%Pump(1)%Speed = (-data%State%Pump(1)%RateChange*data%State%Pump(1)%time_step)+data%State%Pump(1)%N_old
        else
            data%State%Pump(1)%Speed = data%State%Pump(1)%N_new
        end if
        !=======================================================================
        
        Call Pump_OnMode_Solver(1)
        
    else
        
        if ((any(data%State%Pump(1)%AssignmentSwitchh==(/1,2,3,4,9,10/))) .and. (data%State%Pump(1)%Switch==-1)) then
            data%State%Pump(1)%SoundBlower = .true.
        else
            data%State%Pump(1)%SoundBlower = .false.
        end if
        
        if ((any(data%State%Pump(1)%AssignmentSwitchh==(/1,2,3,4,9,10/))) .and. (data%State%Pump(1)%Switch==-1) .and. (data%State%Pump(1)%PowerFailMalf==0) .and. (data%State%Pump(1)%Failure==0)) then
            data%State%Pump(1)%BLWR = 1
        else
            data%State%Pump(1)%BLWR = 0
        end if
        
        
        Call Pump_OffMode_Solver(1)
        data%State%Pump(1)%K_throttle = 0
    
    end if
    
    
    data%State%Pump(1)%N_old = data%State%Pump(1)%Speed
    
              
              
end subroutine Pump1_MainSolver